<?php
//Die Funktion berprft die Eingaben eines neuen Users
function checknewuser($username,$vorname,$nachname,$email,$passwort,$confirm_passwort)
{
	$check = 0;
	if (!$username) { $check = 0; }
		elseif(!$vorname) { $check = 0; }
			elseif(!$nachname) { $check = 0; }
				elseif (!$email) { $check = 0; }
					elseif(!$passwort) { $check = 0; }
						elseif(!$confirm_passwort) { $check = 0; }
							
							else {
								if ($passwort == $confirm_passwort) {
									$check = 1;
								}else {
									$check = 0;
								}
							}
return $check;
}

// Das Barth77 - Verfahren - Verschlsselung mit Zufallszahlen: niemals ist die erste Verschlsselung gleich der Anderen!
// encoding
function encode_barth77($var) {
$var = base64_encode($var);
// Ermittlung von 3 Zufallszahlen
$rand1 = rand(0,30);
$rand2 = rand(0,10);
$rand3 = rand(0,30);

$count = strlen($var); // Ermittlung der Lnge des bergebenden Strings der verschlsselt werden soll
// bergabe der Zufallszahlen in ein Array
$new_string[0] = $rand1."|";
$new_string[1] = $rand2."|";
$new_string[2] = $rand3."|";
	for ($i=3;$i <= $count+2;$i++) {
		// Jedes Zeichen der zu verschlsselnden Zeichenkette wird in sein ASCII - Gegenstck (eine Zahl) umgewandelt
		// wobei dieser Zahl die 3 Zufallszahlen auf- bzw. abgerechnet werden
		$new_string[$i] = ord($var[$i-3])+$rand1-$rand2+$rand3."|";
	}
	// Das entstandene Array wird in eine Zeichenkette zurckverwandelt...
	$new_string = join("",$new_string);
	// ...und zustzlich mit base64_encode() verschlsselt...
	$new_string = base64_encode($new_string);
return $new_string; // ...und zurckgegeben.
}

// decoding
function decode_barth77($string) {
	$string = base64_decode($string);
	$array = explode("|",$string);
	$count = count($array);
	$rand1 = $array[0];
	$rand2 = $array[1];
	$rand3 = $array[2];
	for ($i=3 ;$i <= $count-2;$i++) {
		$new_array[$i] = chr($array[$i]-$rand1+$rand2-$rand3);
	}
	$var = join("",$new_array);
	$var = base64_decode($var);
return $var;
}

// Funktion die prft, ob eine Datei mit dem gewollten Usernamen bereits existiert
function checkfileexist ($username) {
	$datei = "users/".$username.".php";
	$check = 1;
	if(file_exists($datei)) {
		$check = 0;
	}
	
return $check;
}
// Funktion die auf Flle der Variablen prft
function checkform($var) {
$check = 1;
if (!$var) { $check = 0; }
	else { $check = 1; }
return $check;
}

// Funktion checkt ob Cookiedaten == Daten der gespeicherten Benutzerdatei
function checkdata($cookie_username,$cookie_passwort) {
$username = decode_barth77($cookie_username);
$fileexist = checkfileexist($username);
$check = 0;
if ($fileexist == 0) { // d.h. Die Datei existiert!
	include ("users/".$username.".php");
	$cookie_passwort = decode_barth77($cookie_passwort);
	$verschlpasswort = decode_barth77($verschlpasswort);
	if ($cookie_passwort == $verschlpasswort) {
		$check = 1;
	}else {
		$check = 0;
	}
}else {
	$check = 0;
}
return $check; // Nur wenn check 1 wird, darf das Hauptprogramm abgespielt werden!!
			   // Eine entsprechende Fallunterscheidung muss daher an den Anfang einer jeden Datei geschehen!
}
// Funktion die das Session - Verzeichnis von leeren und ungltigen Dateien subert
function saeubere() {
	$hdl = opendir ('sessions/');
		$i = 0;
		while ($res = readdir ($hdl)) {
			if ($i >=2){
				if (filesize("sessions/".$res) == 0) {
					unlink ("sessions/".$res); 
				 }else{
					include ("sessions/".$res);
					$zeit = $logtime+7200;
					if (time() >= $zeit) {
						
						unlink ("sessions/".$res);
					}
				}
			}$i++;	
		}
}

// $verzeichnis_sessions muss ohne / am Ende bergeben werden
function session_begin($verzeichnis_sessions="sessions") {
if ($verzeichnis_sessions != "?") {
	do {
		$rand1 = rand(1,50);
		$rand2 = rand(1,50);
		$session_name = encode_barth77($rand1.$rand2);
	}while (file_exists($verzeichnis_sessions."/".$session_name.".ses") == 1);
}else {
	// Hilfetext erscheint, wenn ein '?' bergeben wird
	echo "******** session_begin( [\$verzeichnis_sessions] ) ************<p>
		Die Funktion ermittelt einen eindeutigen Namen fr eine Session.<br>Dieser
		 wird z.B. in der Funktion session_setvar() bentigt.<p>Parameter:<p>
		 Verzeichnis, in der die Sessions gelagert werden sollen; Ohne / am Ende)";
}

return $session_name; // Rckgabe des Namen der gesetzten Session
}

function session_del($sessid="default",$sessdir="sessions") {
	if ($sessid != "?") {
		unlink($sessdir."/".$sessid.".ses");
	}else{ //Hilfetext
		echo "******** session_del( [ \$sessid,\$sessdir ] ) ************<p>
			Die Funktion beendet eine Session indem sie die entsprechende Datei (sessid)<br>
			im Verzeichnis sessdir lscht.<p>
			Parameter:<p>
			sessid - Name der Session<br>
			sessdir - Verzeichnis der Sessions (optional; Standard: sessions)";
	}
}

// Funktion setzt in eine (bereits bestehende) Session eine Variable ($set_var)
// bentigt werden: Das Verzeichnis in der die Session liegt (ohne / am Ende)
//					Der Name der Session (nicht der Dateiname)
//					Der Name der Variablen die gespeichert werden soll
//					Der Wert der Variablen die gespeichert werden soll
function session_setvar($session_name="default",$name_var="default",$set_var="default",$session_verzeichnis="sessions") {
if ($session_name != "?") {
	
	$fd = fopen($session_verzeichnis."/".$session_name.".ses","a+");
	fwrite ($fd, "<?php \$".$name_var." = '".$set_var."'; ?>\r\n");
	
	fclose($fd);
	include ($session_verzeichnis."/".$session_name.".ses");
	if (!$logtime) {
		$fd = fopen($session_verzeichnis."/".$session_name.".ses","a+");
		fwrite ($fd, "<?php \$logtime = ".time()."; ?>\r\n");
	
	fclose($fd);
	}
}else { // Hilfetext
	echo "******** session_setvar( [ \$session_verzeichnis,\$session_name,\$name_var,\$set_var ] ) ************<p>
		Die Funktion schreibt in eine Session (session_name) im angegebenen Verzeichnis (session_verzeichnis)<br>
		eine Variable mit dem Namen name_var und dem Wert set_var.<br>In eine session wird zustzlich die Variable logtime mit dem Wert des momentanen UNIX-Timestamp eingetragen,<br>
		um von der Funktion 'saeubere' mit erfasst zu werden.
		<p>Parameter:<p>session_verzeichnis - Verzeichnis in der die Session liegt (ohne / am Ende; optional - Standard: ../sessions)<br>
		session_name - Name der Session, die angesprochen werden soll (ohne Extension .ses)<br>
		name_var - Bezeichner der Variablen, die gesetzt werden soll<br>
		set_var - Wert der gesetzt werden soll";
}
}
?>